Bug 803692 - Converging exclusive gateway does not work according to documentation
Converging exclusive gateway does not work according to documentation
Status: VERIFIED
Product: JBoss Enterprise BRMS Platform 5
Classification: JBoss
Component: jBPM 5 (Show other bugs)
BRMS 5.3.0.GA
Unspecified Unspecified
unspecified Severity medium
: ---
: BRMS 5.3.0.GA
Assigned To: Kris Verlaenen
Radovan Synek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-03-15 08:40 EDT by Radovan Synek
Modified: 2012-05-03 23:48 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Radovan Synek 2012-03-15 08:40:24 EDT
Description of problem:

Documentation chapter 5.6.2:
...XOR or exclusive means that it continues as soon as one of its incoming branches has been completed. If it is triggered from more than one incoming connection, it will trigger the next node for each of those triggers.

Following reproducer shows that after the first triggering of converging XOR gateway no more tokens go through it:
1. 2 of 3 outgoing flows from OR gateway have satisfied their condition.
2. First path (script1) is taken and converging XOR gateway is triggered.
3. Final script task and end node is triggered.
4. Second path (script2) is taken, but XOR gateway is not triggered.

Here is a pull request with the reproducer, check also console output:
https://github.com/droolsjbpm/jbpm/pull/56
commit:
https://github.com/rsynek/jbpm/commit/5b4d87a4c36751ae1a5c8357ab8660d437dd2a0a
Comment 2 Kris Verlaenen 2012-04-11 12:04:23 EDT
The issue was not with the converging XOR gateway, but with the inclusive diverging gateway, that wasn't creating all node instances that will be triggered before triggering the first one, leading to an early implicit termination of the process instance.
Comment 3 Ryan Zhang 2012-04-23 03:37:15 EDT
Update status to ON_QA. Please verify them against ER6.

Note You need to log in before you can comment on or make changes to this bug.